/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * compiler.h -- Compiler-dependent definitions
 */

#ifndef COMPILER_H_
#define COMPILER_H_

/*
 * Force symbols visibility to hidden (assume that all symbols resolve within
 * the final binary). This avoids generating GOT/PLT relocations and makes the
 * ELF to EFI binary conversion much easier.
 */
#ifndef __COM32__
#  if __GNUC__ >= 4
#     pragma GCC visibility push(hidden)
#  else
#     error "gcc v4.0 or later required."
#  endif
#endif

#define EXTERN extern
#define INLINE __inline__

#ifdef __x86_64__
#  define CDECL
#else
#  define CDECL  __attribute__ ((cdecl,regparm(0)))
#endif

#define UNUSED_PARAM(_param_) _param_ __attribute__ ((__unused__))

#endif /* !COMPILER_H_ */
