/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * disk.h -- Disk abstraction shared by both low-level and high-level APIs
 */

#ifndef DISK_H_
#define DISK_H_

typedef struct disk_t {
   uintptr_t firmware_id;
   bool use_edd;
   uint32_t cylinders;
   uint32_t heads_per_cylinder;
   uint32_t sectors_per_track;
   uint16_t bytes_per_sector;
} disk_t;

#endif
