/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * efi_info.h --
 *
 *      Define a structure that a generic loader can use to pass EFI
 *      information to the kernel.
 */

#ifndef EFI_INFO_H_
#define EFI_INFO_H_

#include <stdint.h>
#include <stdbool.h>

typedef struct {
   bool valid;                /* EFI info is valid? */
   uint64_t systab;           /* EFI system table pointer */
   uint32_t systab_size;      /* System table size */
   void *mmap;                /* EFI_MEMORY_DESCRIPTOR structures */
   uint32_t num_descs;        /* Number of EFI memory descriptors */
   uint32_t desc_size;        /* Size of each EFI memory descriptor */
   uint32_t version;          /* Version of the EFI memory descriptors */
} efi_info_t;

#endif
