/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * sm_bios.h -- SMBIOS structures definitions
 */

#ifndef SM_BIOS_H_
#define SM_BIOS_H_

#include <sys/types.h>

#define SMBIOS_EPS_SIGNATURE       "_SM_"
#define SMBIOS_EPS_SIGNATURE_LEN   4
#define SMBIOS_PARAGRAPH_SIZE      16

#pragma pack(1)
typedef struct {
   char     anchorString[SMBIOS_EPS_SIGNATURE_LEN];   /* '_SM_' */
   uint8_t  checksum;
   uint8_t  length;
   uint8_t  majorVersion;
   uint8_t  minorVersion;
   uint16_t maxStructSize;
   uint8_t  entryPointRevision;
   uint8_t  formattedArea[5];
   char     intermediateAnchorString[5];    /* '_DMI_' */
   uint8_t  intermediateChecksum;
   uint16_t SMBIOSStructTableLength;
   uint32_t SMBIOSStructTableAddress;
   uint16_t SMBIOSStructNumber;
   uint8_t  versionBCD;
} SMBIOS_entry_point_t;
#pragma pack()

#endif /* !SM_BIOS_H_ */
