/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * stddef.h
 */

#ifndef _STDDEF_H
#define _STDDEF_H

#include <compiler.h>

#define _SIZE_T
#if defined(_MSC_VER)
#   ifdef __x86_64__
       typedef unsigned __int64        size_t;
#   else
       typedef unsigned int            size_t;
#   endif
#elif defined(__GNUC__)
#   ifdef __x86_64__
       typedef unsigned long long int  size_t;
#   else
       typedef unsigned int            size_t;
#   endif
#else
#   error "Need compiler define"
#endif

#define _PTRDIFF_T
#if defined(_MSC_VER)
#   ifdef __x86_64__
       typedef __int64                 ptrdiff_t;
#   else
       typedef signed int              ptrdiff_t;
#   endif
#elif defined (__GNUC__)
#   ifdef __x86_64__
       typedef signed long long int    ptrdiff_t;
#   else
       typedef signed int              ptrdiff_t;
#   endif
#else
#   error "Need compiler define"
#endif

#undef NULL
#define NULL   ((void *)0)

#undef offsetof
#define offsetof(_type_, _field_)   ((size_t)&((_type_ *)0)->_field_)

#endif /* !_STDDEF_H */
