/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * string.h
 */

#ifndef _STRING_H
#define _STRING_H

#include <compiler.h>
#include <stddef.h>

EXTERN int strncasecmp(const char *, const char *, size_t);
EXTERN char *strcat(char *, const char *);
EXTERN char *strchr(const char *, int);
EXTERN int strcmp(const char *, const char *);
EXTERN char *strcpy(char *, const char *);
EXTERN size_t strlen(const char *);
EXTERN int strncmp(const char *, const char *, size_t);
EXTERN char *strstr(const char *, const char *);
EXTERN char *strdup(const char *src);

EXTERN void *memchr(const void *, int, size_t);
EXTERN int memcmp(const void *, const void *, size_t);
EXTERN void *memcpy(void *, const void *, size_t);
EXTERN void *memmove(void *, const void *, size_t);
EXTERN void *memset(void *, int, size_t);

#endif /* !_STRING_H */
