/*******************************************************************************
 * Copyright (c) 2008-2011 VMware, Inc.  All rights reserved.
 *
 * This file is part of the esxboot project.
 *
 * esxboot is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation version 2 and no later version.
 *
 * esxboot is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License version 2 for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 ******************************************************************************/

/*
 * apple.h -- Apple-specific EFI protocols definitions
 *
 *      This protocol is available on Apple platforms. It is an UGA extension
 *      which allows to retrieve the framebuffer properties.
 */

#ifndef EFI_APPLE_H_
#define EFI_APPLE_H_

#define APPLE_BOOT_VIDEO_PROTOCOL_GUID \
   { 0xe316e100, 0x0751, 0x4c49, {0x90, 0x56, 0x48, 0x6C, 0x7e, 0x47, 0x29, 0x03} }

typedef struct _APPLE_BOOT_VIDEO_PROTOCOL _APPLE_BOOT_VIDEO_PROTOCOL;

typedef EFI_STATUS (EFIAPI *APPLE_BOOT_VIDEO_GET_FRAMEBUFFER) (
   IN struct _APPLE_BOOT_VIDEO_PROTOCOL *This,
   OUT UINT32 *BaseAddr,
   OUT UINT32 *Size,
   OUT UINT32 *BytesPerRow,
   OUT UINT32 *Width,
   OUT UINT32 *Height,
   OUT UINT32 *ColorDepth);

typedef struct _APPLE_BOOT_VIDEO_PROTOCOL {
   APPLE_BOOT_VIDEO_GET_FRAMEBUFFER GetFramebuffer;
} APPLE_BOOT_VIDEO_PROTOCOL;

#endif /* !EFI_APPLE_H_ */
